/* Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved. */

/* TERATERM.EXE, Japanese character code conversion */
#include "teraterm.h"

WORD SJIS2JIS(WORD KCode)
{
  WORD x0,x1,x2,y0;
  BYTE b = LOBYTE(KCode);

  if ((b>=0x40) && (b<=0x7f))
  {
    x0 = 0x8140;
    y0 = 0x2121;
  }
  else if ((b>=0x80) && (b<=0x9e))
  {
    x0 = 0x8180;
    y0 = 0x2160;
  }
  else {
    x0 = 0x819f;
    y0 = 0x2221;
  }
  if (HIBYTE(KCode) >= 0xe0)
  {
    x0 = x0 + 0x5f00;
    y0 = y0 + 0x3e00;
  }
  x1 = (KCode-x0) / 0x100;
  x2 = (KCode-x0) % 0x100;
  return (y0 + x1*0x200 + x2);
}

WORD SJIS2EUC(WORD KCode)
{
  return (SJIS2JIS(KCode) | 0x8080);
}

WORD JIS2SJIS(WORD KCode)
{
  WORD n1, n2, SJIS;

  n1 = (KCode-0x2121) / 0x200;
  n2 = (KCode-0x2121) % 0x200;

  if (n1<=0x1e)
    SJIS = 0x8100 + n1*256;
  else
    SJIS = 0xC100 + n1*256;

  if (n2<=0x3e)
    return (SJIS + n2 + 0x40);
  else if ((n2>=0x3f) && (n2<=0x5d))
    return (SJIS + n2 + 0x41);
  else
    return (SJIS + n2 - 0x61);
}

