/* Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved. */

/* TERATERM.EXE, DDE routines */
#include "teraterm.h"
#include "tttypes.h"
#include <ddeml.h>
#include "ttwinman.h"
#include "ttftypes.h"
#include "filesys.h"
#include "clipboar.h"

#define ServiceName "TERATERM"
#define ItemName "DATA"

char TopicName[21] = "";
HCONV ConvH = NULL;
BOOL AdvFlag = FALSE;
BOOL CloseTT = FALSE;

static BOOL DdeCmnd = FALSE;

static DWORD Inst = 0;
static HSZ Service = NULL;
static HSZ Topic = NULL;
static HSZ Item = NULL;
static HWND HWndDdeCli = NULL;

static char ParamFileName[81];
static WORD ParamBinaryFlag;
static WORD ParamAppendFlag;
static WORD ParamXmodemOpt;

#define CBBufSize 83

void GetClientHWnd(PCHAR HWndStr)
{
  int i;
  BYTE b;
  LONG HCli;

  HCli = 0;
  i = 0;
  b = HWndStr[0];
  while (b > 0)
  {
    if (b <= 0x39)
      HCli = (HCli << 4) + (b-0x30);
    else
      HCli = (HCli << 4) + (b-0x37);
    i++;
    b = HWndStr[i];
  }
  HWndDdeCli = (HWND)HCli;
}

void Byte2HexStr(BYTE b, LPSTR HexStr)
{
  if (b<0xa0)
    HexStr[0] = 0x30 + (b >> 4);
  else
    HexStr[0] = 0x37 + (b >> 4);
  if ((b & 0x0f) < 0x0a)
    HexStr[1] = 0x30 + (b & 0x0f);
  else
    HexStr[1] = 0x37 + (b & 0x0f);
}

void SetTopic()
{
  WORD w;

  w = HIWORD(HVTWin);
  Byte2HexStr(HIBYTE(w),&(TopicName[0]));
  Byte2HexStr(LOBYTE(w),&(TopicName[2]));
  w = LOWORD(HVTWin);
  Byte2HexStr(HIBYTE(w),&(TopicName[4]));
  Byte2HexStr(LOBYTE(w),&(TopicName[6]));
  TopicName[8] = 0;
}

HDDEDATA WildConnect(HSZ ServiceHsz, HSZ TopicHsz, WORD ClipFmt)
{
  HSZPAIR Pairs[2];
  BOOL Ok;

  Pairs[0].hszSvc  = Service;
  Pairs[0].hszTopic = Topic;
  Pairs[1].hszSvc = NULL;
  Pairs[1].hszTopic = NULL;

  Ok = FALSE;

  if ((ServiceHsz == 0) && (TopicHsz == 0))
    Ok = TRUE;                 
  else
    if ((TopicHsz == 0) &&
	(DdeCmpStringHandles(Service, ServiceHsz) == 0))
      Ok = TRUE;
    else
      if ((DdeCmpStringHandles(Topic, TopicHsz) == 0) &&
	  (ServiceHsz == 0))
        Ok = TRUE;

  if (Ok)
    return DdeCreateDataHandle(Inst, (LPBYTE)&Pairs, sizeof(Pairs),
	NULL, NULL, ClipFmt, NULL);
  else
    return 0;
}

  BOOL DDEGet1(PBYTE b)
  {
    if (cv.DCount <= 0) return FALSE;
    *b = ((LPSTR)cv.LogBuf)[cv.DStart];
    cv.DStart++;
    if (cv.DStart>=InBuffSize)
      cv.DStart = cv.DStart-InBuffSize;
    cv.DCount--;
    return TRUE;
  }

  LONG DDEGetDataLen()
  {
    BYTE b;
    LONG Len;
    int Start, Count;

    Len = cv.DCount;
    Start = cv.DStart;
    Count = cv.DCount;
    while (Count>0)
    {
      b = ((LPSTR)cv.LogBuf)[Start];
      if ((b==0) || (b==0xFF)) Len++;
      Start++;
      if (Start>=InBuffSize) Start = Start-InBuffSize;
      Count--;
    }
    return Len;
  }

HDDEDATA AcceptRequest(HSZ ItemHSz)
{
  BYTE b;
  BOOL Unlock;
  HDDEDATA DH;
  LPSTR DP;
  int i;

  if (! DDELog) return 0;
  if (DdeCmpStringHandles(ItemHSz, Item) != 0) return 0;
  if (cv.HLogBuf==0) return 0;

  if (cv.LogBuf==NULL)
  {
    Unlock = TRUE;
    cv.LogBuf = GlobalLock(cv.HLogBuf);
    if (cv.LogBuf == NULL) return 0;
  }
  else Unlock = FALSE;

  DH = DdeCreateDataHandle(Inst,NULL,DDEGetDataLen()+1,NULL,
                           Item,CF_OEMTEXT,NULL);
  DP = DdeAccessData(DH,NULL);
  if (DP != NULL)
  {
    i = 0;
    while (DDEGet1(&b))
    {
      if ((b==0) || (b==0xFF))
      {
        DP[i] = 0xFF;
        DP[i+1] = 0xFE | (b & 1);
        i = i + 2;
      }
      else {
        DP[i] = b;
        i++;
      }
    }
    DP[i] = 0;
    DdeUnaccessData(DH);
  }

  if (Unlock)
  {
    GlobalUnlock(cv.HLogBuf);
    cv.LogBuf = NULL;
  }
  return DH;
}

BOOL AcceptPoke(HSZ ItemHSz, WORD ClipFmt,
  HDDEDATA Data)
{
  LPSTR DataPtr;
  DWORD DataSize;

  if (TalkStatus != IdTalkKeyb) return FALSE;

  if ((ClipFmt!=CF_TEXT) && (ClipFmt!=CF_OEMTEXT)) return FALSE;

  if (DdeCmpStringHandles(ItemHSz, Item) != 0) return FALSE;

  DataPtr = DdeAccessData(Data,&DataSize);
  if (DataPtr==NULL) return FALSE;

  CBDDE = TRUE;
  CBRetrySend = FALSE;
  CBRetryEcho = FALSE;
  CBSendCR = FALSE;
  CBMemHandle = GlobalAlloc(GHND, CBBufSize);
  if (CBMemHandle != 0)
  {
    CBMemPtr = GlobalLock(CBMemHandle);
    if (CBMemPtr != NULL)
    {
      TalkStatus = IdTalkCB;
      memcpy(CBMemPtr,DataPtr,DataSize);
    }
  }
  if (TalkStatus != IdTalkCB) CBEndPaste();
  DdeUnaccessData(Data);
  return (TalkStatus==IdTalkCB);
}

#define CmdSetHWnd	' '
#define CmdSetFile      '!'
#define CmdSetBinary    '"'
#define CmdSetAppend    '#'
#define CmdSetXmodemOpt '$'

#define CmdBPlusRecv    '%'
#define CmdBPlusSend    '&'
#define CmdChangeDir    0x27
#define CmdCloseWin	'('
#define CmdKmtRecv      ')'
#define CmdKmtSend      '*'
#define CmdLogClose     '+'
#define CmdLogOpen      ','
#define CmdLogPause     '-'
#define CmdLogStart     '.'
#define CmdLogWrite     '/'
#define CmdQVRecv       '0'
#define CmdQVSend       '1'
#define CmdSendFile     '2'
#define CmdShowMin      '3'
#define CmdShowRestore  '4'
#define CmdXmodemSend   '5'
#define CmdXmodemRecv   '6'
#define CmdZmodemSend   '7'
#define CmdZmodemRecv   '8'

HDDEDATA AcceptExecute(HSZ TopicHSz, HDDEDATA Data)
{
  char Command[82];

  if (DdeCmpStringHandles(TopicHSz, Topic) != 0)
    return DDE_FNOTPROCESSED;

  if (DdeGetData(Data,Command,sizeof(Command),0) == 0)
    return DDE_FNOTPROCESSED;

  switch (Command[0]) {
    case CmdSetHWnd:
      GetClientHWnd(&Command[1]);
      if (cv.Ready)
        SetDdeComReady(1);
      break;
    case CmdSetFile:
      strcpy(ParamFileName,&(Command[1]));
      break;
    case CmdSetBinary:
    case CmdSetAppend:
      ParamAppendFlag = Command[1] & 1;
      break;
    case CmdSetXmodemOpt:
      ParamXmodemOpt = Command[1] & 3;
      if (ParamXmodemOpt==0) ParamXmodemOpt = 1;
      break;
    case CmdBPlusRecv:
      if ((FileVar==NULL) && NewFileVar(&FileVar))
      {
        DdeCmnd = TRUE;
        BPStart(IdBPReceive);
      }
      else
        return DDE_FNOTPROCESSED;
      break;
    case CmdBPlusSend:
      if ((FileVar==NULL) && NewFileVar(&FileVar))
      {
        FileVar->DirLen = 0;
        strcpy(FileVar->FullName,ParamFileName);
        FileVar->NumFname = 1;
        DdeCmnd = TRUE;
        BPStart(IdBPSend);
      }
      else
        return DDE_FNOTPROCESSED;
      break;
    case CmdChangeDir:
      strcpy(ts.FileDir,ParamFileName);
      break;
    case CmdCloseWin:
      CloseTT = TRUE;
      break;
    case CmdKmtRecv:
      if ((FileVar==NULL) && NewFileVar(&FileVar))
      {
        DdeCmnd = TRUE;
        KermitStart(IdKmtReceive);
      }
      else
        return DDE_FNOTPROCESSED;
      break;
    case CmdKmtSend:
      if ((FileVar==NULL) && NewFileVar(&FileVar))
      {
        FileVar->DirLen = 0;
        strcpy(FileVar->FullName,ParamFileName);
        FileVar->NumFname = 1;
        DdeCmnd = TRUE;
        KermitStart(IdKmtSend);
      }
      else
        return DDE_FNOTPROCESSED;
      break;
    case CmdLogClose:
      if (LogVar != NULL) LogEnd();
      break;
    case CmdLogOpen:
      if ((LogVar==NULL) && NewFileVar(&LogVar))
      {
        LogVar->DirLen = 0;
        strcpy(LogVar->FullName,ParamFileName);
        ts.TransBin = ParamBinaryFlag;
        ts.Append = ParamAppendFlag;
        LogStart();
      }
      else
        return DDE_FNOTPROCESSED;
      break;
    case CmdLogPause:
      FLogChangeButton(TRUE);
      break;
    case CmdLogStart:
      FLogChangeButton(FALSE);
      break;
    case CmdLogWrite:
      if (LogVar != NULL)
      {
        _lwrite(LogVar->FileHandle,
                ParamFileName,strlen(ParamFileName));
        LogVar->ByteCount =
          LogVar->ByteCount + strlen(ParamFileName);
        FLogRefreshNum();
      }
      break;
    case CmdQVRecv:
      if ((FileVar==NULL) && NewFileVar(&FileVar))
      {
        DdeCmnd = TRUE;
        QVStart(IdQVReceive);
      }
      else
        return DDE_FNOTPROCESSED;
      break;
    case CmdQVSend:
      if ((FileVar==NULL) && NewFileVar(&FileVar))
      {
        FileVar->DirLen = 0;
        strcpy(FileVar->FullName,ParamFileName);
        FileVar->NumFname = 1;
        DdeCmnd = TRUE;
        QVStart(IdQVSend);
      }
      else
        return DDE_FNOTPROCESSED;
      break;
    case CmdSendFile:
      if ((SendVar==NULL) && NewFileVar(&SendVar))
      {
        SendVar->DirLen = 0;
        strcpy(SendVar->FullName,ParamFileName);
        ts.TransBin = ParamBinaryFlag;
        DdeCmnd = TRUE;
        FileSendStart();
      }
      else
        return DDE_FNOTPROCESSED;
      break;
    case CmdShowMin:
      ShowWindow(HVTWin,SW_MINIMIZE);
      break;
    case CmdShowRestore:
      ShowWindow(HVTWin,SW_RESTORE);
      break;
    case CmdXmodemRecv:
      if ((FileVar==NULL) && NewFileVar(&FileVar))
      {
        FileVar->DirLen = 0;
        strcpy(FileVar->FullName,ParamFileName);
        ts.XmodemOpt = ParamXmodemOpt;
        ts.XmodemBin = ParamBinaryFlag;
        DdeCmnd = TRUE;
        XMODEMStart(IdXReceive);
      }
      else
        return DDE_FNOTPROCESSED;
      break;
    case CmdXmodemSend:
      if ((FileVar==NULL) && NewFileVar(&FileVar))
      {
        FileVar->DirLen = 0;
        strcpy(FileVar->FullName,ParamFileName);
        ts.XmodemOpt = ParamXmodemOpt;
        DdeCmnd = TRUE;
        XMODEMStart(IdXSend);
      }
      else
        return DDE_FNOTPROCESSED;
      break;
    case CmdZmodemRecv:
      if ((FileVar==NULL) && NewFileVar(&FileVar))
      {
        DdeCmnd = TRUE;
        ZMODEMStart(IdZReceive);
      }
      else
        return DDE_FNOTPROCESSED;
      break;
    case CmdZmodemSend:
      if ((FileVar==NULL) && NewFileVar(&FileVar))
      {
        FileVar->DirLen = 0;
        strcpy(FileVar->FullName,ParamFileName);
        FileVar->NumFname = 1;
        ts.XmodemBin = ParamBinaryFlag;
        DdeCmnd = TRUE;
        ZMODEMStart(IdZSend);
      }
      else
        return DDE_FNOTPROCESSED;
      break;
    default:
      return DDE_FNOTPROCESSED;
  }
  return DDE_FACK;
}

HDDEDATA CALLBACK DdeCallbackProc(UINT CallType, UINT Fmt, HCONV Conv,
  HSZ HSz1, HSZ HSz2, HDDEDATA Data, DWORD Data1, DWORD Data2)
{
  switch (CallType) {
    case XTYP_WILDCONNECT:
      return WildConnect(HSz2, HSz1, Fmt);
      break;
    case XTYP_CONNECT:
      if (Conv == 0)
      {
        if ((DdeCmpStringHandles(Topic, HSz1) == 0) &&
            (DdeCmpStringHandles(Service, HSz2) == 0))
        {
          if (cv.Ready)
            SetDdeComReady(1);
	  return 1;
        }
      }
      break;
    case XTYP_CONNECT_CONFIRM:
      ConvH = Conv;
      break;
    case XTYP_ADVREQ:
    case XTYP_REQUEST:
      return AcceptRequest(HSz2);
    case XTYP_POKE:
      if (AcceptPoke(HSz2, Fmt, Data))
        return DDE_FACK;
      break;
    case XTYP_ADVSTART:
      if ((DdeCmpStringHandles(Topic, HSz1) == 0) &&
          (DdeCmpStringHandles(Item, HSz2) == 0) &&
          ! AdvFlag)
      {
        AdvFlag = TRUE;
        return 1;
      }
      break;
    case XTYP_ADVSTOP:
      if ((DdeCmpStringHandles(Topic, HSz1) == 0) &&
          (DdeCmpStringHandles(Item, HSz2) == 0) &&
          AdvFlag)
      {
        AdvFlag = FALSE;
        return 1;
      }
      break;
    case XTYP_DISCONNECT:
      ConvH = 0;
      HWndDdeCli = 0;
      PostMessage(HVTWin,WM_USER+MsgDdeEnd,0,0);
      break;
    case XTYP_EXECUTE:
      return AcceptExecute(HSz1, Data);
  }  /* switch (CallType) */

  return 0;
}

BOOL InitDDE()
{
  BOOL Ok;

  if (ConvH != 0) return FALSE;

  Ok = TRUE;

  if (DdeInitialize(&Inst,&DdeCallbackProc,0,0) == DMLERR_NO_ERROR)
  {
    Service= DdeCreateStringHandle(Inst, ServiceName, CP_WINANSI);
    Topic  = DdeCreateStringHandle(Inst, TopicName, CP_WINANSI);
    Item   = DdeCreateStringHandle(Inst, ItemName, CP_WINANSI);

    Ok = DdeNameService(Inst, Service, 0, DNS_REGISTER) != 0;
  }
  else
    Ok = FALSE;

  DDELog = TRUE;
  CloseTT = FALSE;

  if (Ok & cv.Ready)
    Ok = CreateLogBuf();

  if (! Ok) EndDDE();
  return Ok;
}

void SendDDEReady()
{
  GetClientHWnd(TopicName);
  PostMessage(HWndDdeCli,WM_USER+MsgDdeReady,0,0);
}

void EndDDE()
{
  if (Inst != 0)
  {
    if (Service != 0)
      DdeFreeStringHandle(Inst, Service);
    if (Topic != 0)
      DdeFreeStringHandle(Inst, Topic);
    if (Item != 0)
      DdeFreeStringHandle(Inst, Item);
    DdeUninitialize(Inst);
    Inst = 0;
  }
  TopicName[0] = 0;
  ConvH = NULL;
  HWndDdeCli = NULL;
  AdvFlag = FALSE;

  DDELog = FALSE;
  FreeLogBuf();
}

void DDEAdv()
{
  if ((! AdvFlag) ||
      (cv.DCount==NULL)) return;
    DdePostAdvise(Inst,Topic,Item);
}

void EndDdeCmnd()
{
  if ((ConvH==0) || (HWndDdeCli==NULL) || (! DdeCmnd)) return;
  PostMessage(HWndDdeCli,WM_USER+MsgDdeCmndEnd,0,0);
  DdeCmnd = FALSE;
}

void SetDdeComReady(WORD Ready)
{
  if (HWndDdeCli==NULL) return;
  PostMessage(HWndDdeCli,WM_USER+MsgDdeComReady,Ready,0);
}

